Imports System
Imports System.Web
Imports System.Data
Imports System.Collections
Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Net
Imports System.Net.Mail

Partial Class EmailParser
    Inherits Page

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not Page.IsPostBack Then
            EmailReceive()
        End If
    End Sub

    'Version 0.1
    'Written by Hunter Beanland - www.beanland.net.au
    'This code is the beginning of an SMTP email parser (there is no native .NET 2.0 class to do this - crazy. You can send them, but not read them).
    'I tried to make this code as compact and as simple as possible - at least in the 1st version! Sorry if my techniques are a bit dodgy - least it works.
    'Anyway, this is where I got up to. It runs and reads encoded emails, but it doesn't read the attachments or decode the QuotedPrintable bits yet, 
    'but that can be added fairly easily (framework is there already for this).
    'I abandoned this code (for the time being at least) as I found a better way to read email - the old ClassicASP way.
    'Create a reference to Microsoft CDO for Windows 2000, then you can use the CDO object to do everything - easy.
    'If you improve this, please send me a copy.

    Public Sub EmailReceive()
        'Get email files from SMTP mailbox folder
        Dim objSMTP As New System.Net.Mail.SmtpClient
        'Web.Config settings to use the SmtpClient.PickupDirectoryLocation - we will hard code for this demo.
        '<mailSettings>
        '   <smtp deliveryMethod="PickupDirectoryFromIis">
        '    <!--network, PickupDirectoryFromIis, SpecifiedPickupDirectory-->
        '    <network host="server" port="25" userName="username" password="password" />
        '    <specifiedPickupDirectory pickupDirectoryLocation="c:\Inetpub\mailroot\Pickup" />
        '   </smtp>
        '</mailSettings>
        'Dim strMailbox As String = objSMTP.PickupDirectoryLocation.Substring(0, objSMTP.PickupDirectoryLocation.LastIndexOf("\")) & "\Mailbox"
        Dim strMailbox As String = "c:\Inetpub\mailroot\Mailbox" 'Hardcoded version of the above
        Dim aryFiles() As String = Directory.GetFiles(strMailbox, "*.eml")
        Dim strFile As String
        Dim Fs As FileStream = Nothing
        Dim reader As System.IO.StreamReader = Nothing
        Dim strLine, strLastLine As String
        Dim intSection As Int16
        Dim blnPastSubHeader As Boolean
        Dim objEmail As EmailDetails
        Dim sb As New StringBuilder
        Dim sbDisplay As New StringBuilder

        sbDisplay.Append("SMTP Mailbox: ")
        sbDisplay.Append(strMailbox)
        sbDisplay.Append("<br />Emails: ")
        sbDisplay.Append(aryFiles.Length)

        For Each strFile In aryFiles
            Try
                Trace.Write(strFile, "strFile")
                Fs = New FileStream(strFile, FileMode.Open, FileAccess.Read, FileShare.None)
                reader = New System.IO.StreamReader(Fs, System.Text.Encoding.ASCII, True)
            Catch ex As Exception
                Trace.Warn(ex.Message, "EmailReceiver file open")
                If Not IsNothing(reader) Then reader.Close()
                If Not IsNothing(Fs) Then Fs.Close()
            End Try
            intSection = 0
            strLastLine = String.Empty
            objEmail = New EmailDetails
            objEmail.FileName = strFile
            If Not IsNothing(reader) Then
                'Get next field including folds (multi line)
                If Not reader.EndOfStream Then strLastLine = reader.ReadLine
                While Not reader.EndOfStream
                    strLine = reader.ReadLine
                    'read 1 line ahead to see is field is folded
                    If (intSection = 0 And strLine = objEmail.Boundary) OrElse (intSection > 0 And strLine.StartsWith(objEmail.Boundary)) Then
                        If intSection = 0 And strLastLine <> String.Empty Then
                            ProcessHeaderField(objEmail, strLastLine)
                            strLastLine = String.Empty
                        End If
                        intSection += 1
                        If objEmail.Boundary = String.Empty Then
                            'not multi part.
                            blnPastSubHeader = True
                        Else
                            blnPastSubHeader = False
                        End If
                        If sb.Length > 0 Then
                            ProcessPartBody(objEmail, sb.ToString)
                            sb.Length = 0
                        End If
                    End If
                    If intSection = 0 Then
                        'Scan email header
                        If (Regex.IsMatch(strLine, "(\A\S+): ") Or strLine = String.Empty) And strLastLine <> String.Empty Then
                            ProcessHeaderField(objEmail, strLastLine)
                            strLastLine = strLine
                        Else
                            strLastLine &= strLine
                        End If
                    Else
                        'Next Section/Part starts
                        If Not blnPastSubHeader Then
                            If (Regex.IsMatch(strLine, "(\A\S+): ") Or strLine = String.Empty) And strLastLine <> String.Empty Then
                                ProcessPartField(objEmail, strLastLine)
                                strLastLine = strLine
                            Else
                                strLastLine &= strLine
                            End If
                            If strLine = String.Empty Then blnPastSubHeader = True
                            sb.Length = 0
                        Else
                            sb.Append(strLine)
                            sb.Append(vbCrLf)
                        End If
                    End If

                End While 'reader.EndOfStream
                'If strLastLine <> String.Empty Then ProcessHeaderField(objEmail, strLastLine)
                reader.Close()
                Fs.Close()
            End If 'IsNothing(reader)

            'Display emails onscreen
            Dim intAddress As Int16
            sbDisplay.Append("<hr /><p />File: ")
            sbDisplay.Append(objEmail.FileName)
            sbDisplay.Append("<br />From: ")
            If Not IsNothing(objEmail.From) Then sbDisplay.Append(objEmail.From.DisplayName & " " & objEmail.From.Address)
            sbDisplay.Append("<br />To: ")
            If Not IsNothing(objEmail.To) Then
                For intAddress = 0 To objEmail.To.Length - 1
                    If objEmail.To(intAddress).DisplayName = String.Empty Then
                        sbDisplay.Append(objEmail.To(intAddress).Address & "; ")
                    Else
                        sbDisplay.Append(objEmail.To(intAddress).DisplayName & "=" & objEmail.To(intAddress).Address & "; ")
                    End If
                Next
            End If
            sbDisplay.Append("<br />CC: ")
            If Not IsNothing(objEmail.CC) Then
                For intAddress = 0 To objEmail.CC.Length - 1
                    sbDisplay.Append(objEmail.CC(intAddress).DisplayName & " " & objEmail.CC(intAddress).Address & "; ")
                Next
            End If
            sbDisplay.Append("BCC: ")
            If Not IsNothing(objEmail.BCC) Then
                For intAddress = 0 To objEmail.BCC.Length - 1
                    sbDisplay.Append(objEmail.BCC(intAddress).DisplayName & " " & objEmail.BCC(intAddress).Address & "; ")
                Next
            End If
            sbDisplay.Append("<br />Date: ")
            sbDisplay.Append(objEmail.Date.ToString)
            sbDisplay.Append("<br />Subject: ")
            sbDisplay.Append(objEmail.Subject)
            sbDisplay.Append("<br />BodyText: ")
            sbDisplay.Append(objEmail.BodyText)
            sbDisplay.Append("<br />BodyHTML: ")
            sbDisplay.Append(objEmail.BodyHTML)

            'Delete file now it has been read 
            'File.Delete(strFile) 'Don't delete while we are testing!

        Next 'each strFile
        litEmails.Text = sbDisplay.ToString
    End Sub

    Sub ProcessHeaderField(ByRef CurrentEmail As EmailDetails, ByVal strField As String)
        Dim strFieldName As String

        Trace.Write(strField, "strField")
        If strField.Length = 0 OrElse Not strField.Contains(":") Then Exit Sub
        strFieldName = strField.Substring(0, strField.IndexOf(":"))
        If strField.Length > strFieldName.Length + 2 Then strField = strField.Substring(strField.IndexOf(":") + 2).Trim
        Trace.Write(strFieldName & "=" & strField, "Field")

        Select Case strFieldName
            Case "To", "Cc", "Bcc"
                'To: <x@domain.com>, "my" <support@domain.com>, sales@domain.com
                Try
                    Select Case strFieldName
                        Case "To"
                            CurrentEmail.ToAdd(New Net.Mail.MailAddress(strField))
                        Case "Cc"
                            CurrentEmail.CCAdd(New Net.Mail.MailAddress(strField))
                        Case "Bcc"
                            CurrentEmail.BCCAdd(New Net.Mail.MailAddress(strField))
                    End Select
                Catch
                End Try
            Case "From"
                'To: <x@domain.com>, "my" <support@domain.com>, sales@domain.com
                Try
                    CurrentEmail.From = New Net.Mail.MailAddress(strField)
                Catch
                End Try
            Case "Date"
                'Date: Fri, 1 Nov 2002 15:08 +1100   or   Date: Fri, 2 Jul 2004 18:46:30 +1000
                If Not DateTime.TryParse(strField, CurrentEmail.Date) Then
                    Trace.Write("received date invalid")
                Else
                    'Trace.Write(CurrentEmail.Date.ToString, "date")
                End If
                'If strTemp.Contains(",") Then strLine.Substring(strLine.IndexOf(",") + 1)
                'If strTemp.Contains(",") Then strLine.Substring(strLine.IndexOf(",") + 1)
            Case "Subject"
                'Subject: Mail delivery error
                CurrentEmail.Subject = strField
            Case "Content-Type"
                'multipart/alternative; boundary = "-... | text/plain; charset="shift_jis" | text/html; charset=iso-8859-1
                If strField.Contains("boundary") Then
                    CurrentEmail.Boundary = "--" & strField.Substring(strField.IndexOf("""") + 1, strField.Length - strField.IndexOf("""") - 2)
                ElseIf strField.Contains("charset") Then
                    If strField.Contains("""") Then
                        CurrentEmail.CharSet = strField.Substring(strField.IndexOf("""") + 1, strField.Length - strField.IndexOf("""") - 2)
                    Else
                        CurrentEmail.CharSet = strField.Substring(strField.IndexOf("=") + 1)
                    End If
                End If
            Case "Content-Transfer-Encoding"
                '7bit | 8bit | base64 | quoted-printable
                CurrentEmail.Encoding = strField
        End Select

    End Sub

    Sub ProcessPartField(ByRef CurrentEmail As EmailDetails, ByVal strField As String)
        Dim strFieldName, strCharSet As String
        'Trace.Write(strField, "strField")
        If strField.Length = 0 OrElse Not strField.Contains(":") Then Exit Sub
        strFieldName = strField.Substring(0, strField.IndexOf(":"))
        If strField.Length > strFieldName.Length + 2 Then strField = strField.Substring(strField.IndexOf(":") + 2).Trim
        Trace.Write(strFieldName & "=" & strField, "PartField")

        Select Case strFieldName
            Case "Content-Type"
                'text/plain; charset="shift_jis" | text/html; charset=iso-8859-1 | name="file.txt" |
                If strField.Contains("boundary") Then
                    CurrentEmail.Boundary = "--" & strField.Substring(strField.IndexOf("""") + 1, strField.Length - strField.IndexOf("""") - 2)
                ElseIf strField.Contains("name=") Then
                    CurrentEmail.CurrentPart = "FILE"
                ElseIf strField.Contains("text/plain") Then
                    CurrentEmail.CurrentPart = "TEXT"
                ElseIf strField.Contains("text/html") Then
                    CurrentEmail.CurrentPart = "HTML"
                End If
                If strField.Contains("charset") Then
                    If strField.Contains("""") Then
                        strCharSet = strField.Substring(strField.IndexOf("""") + 1, strField.Length - strField.IndexOf("""") - 2)
                    Else
                        strCharSet = strField.Substring(strField.IndexOf("=") + 1)
                    End If
                    If CurrentEmail.CurrentPart = "TEXT" Then
                        CurrentEmail.BodyTextCharSet = strCharSet
                    ElseIf CurrentEmail.CurrentPart = "HTML" Then
                        CurrentEmail.BodyHTMLCharSet = strCharSet
                    End If
                End If
            Case "Content-Transfer-Encoding"
                '7bit | 8bit | base64 | quoted-printable
                If CurrentEmail.CurrentPart = "TEXT" Then
                    CurrentEmail.BodyTextEncoding = strField
                ElseIf CurrentEmail.CurrentPart = "HTML" Then
                    CurrentEmail.BodyHTMLEncoding = strField
                End If
        End Select
        'Content-Disposition: attachment; filename = "file.txt"
    End Sub

    Sub ProcessPartBody(ByRef CurrentEmail As EmailDetails, ByRef strBody As String)
        'Use the encoding info from the sub header to decode the body text/html
        'Trace.Write(strBody, "strBody")
        Dim strCharSet, strEncoding, strBodyNew As String
        If CurrentEmail.CurrentPart = "FILE" Then
            Exit Sub
        ElseIf CurrentEmail.CurrentPart = "TEXT" Then
            strCharSet = CurrentEmail.BodyTextCharSet
            strEncoding = CurrentEmail.BodyTextEncoding
        ElseIf CurrentEmail.CurrentPart = "HTML" Then
            strCharSet = CurrentEmail.BodyHTMLCharSet
            strEncoding = CurrentEmail.BodyHTMLEncoding
        Else
            strCharSet = "iso-8859-1"
            strEncoding = "8bit"
        End If
        Dim PartEncoding As System.Text.Encoding
        Try
            PartEncoding = System.Text.Encoding.GetEncoding(strCharSet)
        Catch ex As Exception
            PartEncoding = System.Text.Encoding.UTF8
        End Try
        'Decode
        Trace.Write(PartEncoding.EncodingName & " " & strCharSet & " " & strEncoding, "CharSet")
        Try
            Select Case strEncoding
                Case "7bit"
                    strBodyNew = strBody
                Case "8bit"
                    strBodyNew = PartEncoding.GetString(PartEncoding.GetBytes(strBody))
                Case "base64"
                    strBodyNew = PartEncoding.GetString(Convert.FromBase64String(strBody))
                Case "quoted-printable"
                    strBodyNew = ConvertFromQuotePrintable(strBody, PartEncoding)
                Case Else
                    strBodyNew = strBody
            End Select
        Catch ex As Exception
            strBodyNew = "Error decoding email body: " & ex.Message & vbLf & strBody
        End Try
        'store the first complying section.
        If CurrentEmail.CurrentPart = "TEXT" Then
            If CurrentEmail.BodyText.Length = 0 Then CurrentEmail.BodyText = strBodyNew
        ElseIf CurrentEmail.CurrentPart = "HTML" Then
            If CurrentEmail.BodyHTML.Length = 0 Then CurrentEmail.BodyHTML = strBodyNew
        End If
    End Sub

    Function ConvertFromQuotePrintable(ByVal strQP As String, ByVal CharSet As System.Text.Encoding) As String
        'To be built
        'http://en.wikipedia.org/wiki/Quoted_Printable
        Return strQP
    End Function

End Class

Public Class EmailDetails
    'Email details data class
    Public FileName As String = String.Empty
    Public [Date] As DateTime = Now
    Public Subject As String = String.Empty
    Public [To]() As System.Net.Mail.MailAddress
    Public CC() As System.Net.Mail.MailAddress
    Public BCC() As System.Net.Mail.MailAddress
    Public From As System.Net.Mail.MailAddress
    Public Boundary As String = String.Empty
    Public CharSet As String = "iso-8859-1"
    Public Encoding As String = "8bit"
    Public BodyText As String = String.Empty
    Public BodyTextCharSet As String = "iso-8859-1"
    Public BodyTextEncoding As String = "8bit"
    Public BodyHTML As String = String.Empty
    Public BodyHTMLCharSet As String = "iso-8859-1"
    Public BodyHTMLEncoding As String = "8bit"
    Public CurrentPart As String = String.Empty

    Public Sub ToAdd(ByVal EmailAddress As Net.Mail.MailAddress)
        If IsNothing([To]) Then
            ReDim [To](0)
        Else
            ReDim Preserve [To]([To].Length)
        End If
        Try
            [To]([To].Length - 1) = EmailAddress
        Catch ex As Exception
            HttpContext.Current.Trace.Write(ex.Message.ToString, "ToAddError")
        End Try
    End Sub

    Public Sub CCAdd(ByVal EmailAddress As Net.Mail.MailAddress)
        If IsNothing(CC) Then
            ReDim CC(0)
        Else
            ReDim Preserve CC(CC.Length)
        End If
        Try
            CC(CC.Length - 1) = EmailAddress
        Catch ex As Exception
            HttpContext.Current.Trace.Write(ex.Message.ToString, "CCAddError")
        End Try
    End Sub

    Public Sub BCCAdd(ByVal EmailAddress As Net.Mail.MailAddress)
        If IsNothing(BCC) Then
            ReDim BCC(0)
        Else
            ReDim Preserve BCC(BCC.Length)
        End If
        Try
            BCC(BCC.Length - 1) = EmailAddress
        Catch ex As Exception
            HttpContext.Current.Trace.Write(ex.Message.ToString, "BCCAddError")
        End Try
    End Sub
End Class
